var Converter = /** @class */ (function () {
    function Converter() {
    }
    // $("#selector") -> document.getElementById("selector");
    // $("#selector sub-selector") -> document.querySelectorAll("#selector sub-selector");
    Converter.idSelectors = function (input) {
        var pattern = /\$\(\s?('|\")\s?\#([0-9a-zA-Z-_ ]+)\s?('|\")\s?\)/gm;
        return input.replace(pattern, function (match) {
            var regexResult = pattern.exec(match);
            var key = regexResult[2];
            if (key && key.length > 0) {
                if (key.includes(" ")) {
                    return "document.querySelectorAll(\"#" + key + "\")";
                }
                else {
                    return "document.getElementById(\"" + key + "\")";
                }
            }
        });
    };
    // $(".selector") -> document.getElementByClassName("selector");
    // $(".selector sub-selector") -> document.querySelectorAll(".selector sub-selector");
    Converter.classSelectors = function (input) {
        var pattern = /\$\(\s?('|\")\s?\.([0-9a-zA-Z-_\s]+)\s?('|\")\s?\)/gm;
        return input.replace(pattern, function (match) {
            var regexResult = pattern.exec(match);
            var key = regexResult[2];
            if (key && key.length > 0) {
                if (key.includes(" ")) {
                    return "document.querySelectorAll(\"." + key + "\")";
                }
                else {
                    return "document.getElementByClassName(\"" + key + "\")";
                }
            }
        });
    };
    // .html() -> .innerHTML
    // .html(x) -> .innerHTML = x
    Converter.html = function (input) {
        var pattern = /.html\((.*?)\)/gm;
        return input.replace(pattern, function (match) {
            var regexResult = pattern.exec(match);
            var key = regexResult[1];
            var otherKey = regexResult[0];
            if (key && key.length > 0) {
                return ".innerHTML = " + key;
            }
            else if (otherKey && otherKey.length > 0) {
                return ".innerHTML";
            }
        });
    };
    // .text() -> .innerText
    // .text(x) -> .innerText = x
    Converter.text = function (input) {
        var pattern = /.text\((.*?)\)/gm;
        return input.replace(pattern, function (match) {
            var regexResult = pattern.exec(match);
            var key = regexResult[1];
            var otherKey = regexResult[0];
            if (key && key.length > 0) {
                return ".innerText = " + key;
            }
            else if (otherKey && otherKey.length > 0) {
                return ".innerText";
            }
        });
    };
    Converter.convert = function (input, config) {
        var processList = [
            "idSelector",
            "classSelector",
            "html",
        ];
        var output = input;
        var excludeList = [];
        if (config && config.exclude && Array.isArray(config.exclude)) {
            excludeList = config.exclude;
        }
        processList.forEach(function (process) {
            if (!excludeList.includes(process)) {
                output = Converter[process](output);
            }
        });
        return output;
    };
    return Converter;
}());
export default Converter;
